searchNodes=[{"doc":"Analyze wobserver code and exit if errors have been found.","ref":"Mix.Tasks.Analyze.html","title":"Mix.Tasks.Analyze","type":"task"},{"doc":"Analyze wobserver code and exit if errors have been found. The following steps are performed: credo (strict) dialyzer coveralls (&gt;=90% coverage pass)","ref":"Mix.Tasks.Analyze.html#run/1","title":"Mix.Tasks.Analyze.run/1","type":"function"},{"doc":"Run through all the build steps for wobserver.","ref":"Mix.Tasks.Build.html","title":"Mix.Tasks.Build","type":"task"},{"doc":"Run through all the build steps for wobserver. The following steps are performed: gulp (deploy) building assets.ex compile docs hex.build","ref":"Mix.Tasks.Build.html#run/1","title":"Mix.Tasks.Build.run/1","type":"function"},{"doc":"Web based metrics, monitoring, and observer.","ref":"Wobserver.html","title":"Wobserver","type":"module"},{"doc":"Information about Wobserver. Returns a map containing: name , name of :wobserver . version , used :wobserver version. description , description of :wobserver . license , :wobserver license name and link. links , list of name + url for :wobserver related information.","ref":"Wobserver.html#about/0","title":"Wobserver.about/0","type":"function"},{"doc":"Registers external application to integrate with :wobserver . The registration is done by passing a type and the data to register. The data is usually passed on to a specialized function. The following types can be registered: :page , see: Wobserver.Page.register/1 . :metric , see: Wobserver.Util.Metrics.register/1 .","ref":"Wobserver.html#register/2","title":"Wobserver.register/2","type":"function"},{"doc":"Handles memory allocators and their block and carrier size.","ref":"Wobserver.Allocator.html","title":"Wobserver.Allocator","type":"module"},{"doc":"Lists memory allocators and their block and carrier size. The returned maps contain the following information: type , the type of the memory allocator. block , the block size of the memory allocator. (summed over all schedulers) carrier , the carrier size of the memory allocator. (summed over all schedulers)","ref":"Wobserver.Allocator.html#list/0","title":"Wobserver.Allocator.list/0","type":"function"},{"doc":"Page management for custom commands and pages in api and wobserver.","ref":"Wobserver.Page.html","title":"Wobserver.Page","type":"module"},{"doc":"Calls the function associated with the command /page. Returns the result of the function or :page_not_found , if the page can not be found.","ref":"Wobserver.Page.html#call/1","title":"Wobserver.Page.call/1","type":"function"},{"doc":"Find the page for a given command Returns :page_not_found , if no page can be found.","ref":"Wobserver.Page.html#find/1","title":"Wobserver.Page.find/1","type":"function"},{"doc":"List all registered pages. For every page the following information is given: title command api_only refresh","ref":"Wobserver.Page.html#list/0","title":"Wobserver.Page.list/0","type":"function"},{"doc":"Loads custom pages from configuration and adds them to :wobserver . To add custom pages set the :pages option. The :pages option must be a list of page data. The page data can be formatted as: {title, command, callback} {title, command, callback, options} a map with the following fields: title command callback options (optional) For more information and types see: Wobserver.Page.register/1 . Example: config :wobserver , pages : [ { &quot;Example&quot; , :example , fn -&gt; %{ x : 9 } end } ]","ref":"Wobserver.Page.html#load_config/0","title":"Wobserver.Page.load_config/0","type":"function"},{"doc":"Registers a page with :wobserver . Returns true if succesfully added. (otherwise false) The following inputs are accepted: {title, command, callback} {title, command, callback, options} a map with the following fields: title command callback options (optional) The fields are used as followed: title , the name of the page. Is used for the web interface menu. command , single atom to associate the page with. callback , function to be evaluated, when the a api is called or page is viewd. The result is converted to JSON and displayed . options , options for the page. The following options can be set: api_only ( boolean ), if set to true the page won't show up in the web interface, but will only be available as API. refresh ( float , 0-1), sets the refresh time factor. Used in the web interface to refresh the data on the page. Set to 0 for no refresh.","ref":"Wobserver.Page.html#register/1","title":"Wobserver.Page.register/1","type":"function"},{"doc":"Registers a page with :wobserver . The arguments are used as followed: title , the name of the page. Is used for the web interface menu. command , single atom to associate the page with. callback , function to be evaluated, when the a api is called or page is viewd. The result is converted to JSON and displayed . options , options for the page. The following options can be set: api_only ( boolean ), if set to true the page won't show up in the web interface, but will only be available as API. refresh ( float , 0-1), sets the refresh time factor. Used in the web interface to refresh the data on the page. Set to 0 for no refresh.","ref":"Wobserver.Page.html#register/4","title":"Wobserver.Page.register/4","type":"function"},{"doc":"Accepted page formats.","ref":"Wobserver.Page.html#t:data/0","title":"Wobserver.Page.data/0","type":"type"},{"doc":"Page structure. Fields: title , the name of the page. Is used for the web interface menu. command , single atom to associate the page with. callback , function to be evaluated, when the a api is called or page is viewd. The result is converted to JSON and displayed . options , map containing options for the page. Options: api_only ( boolean ), if set to true the page won't show up in the web interface, but will only be available as API. refresh ( float , 0-1), sets the refresh time factor. Used in the web interface to refresh the data on the page. Set to 0 for no refresh.","ref":"Wobserver.Page.html#t:t/0","title":"Wobserver.Page.t/0","type":"type"},{"doc":"Handles Ports and their information.","ref":"Wobserver.Port.html","title":"Wobserver.Port","type":"module"},{"doc":"Lists ports and their block and carrier size. The returned maps contain the following information: id port name links connected input output os_pid","ref":"Wobserver.Port.html#list/0","title":"Wobserver.Port.list/0","type":"function"},{"doc":"Handles basic websocket authentication. A different module with the following methods can be set as :security in the config: authenticate(Conn.t) :: Conn.t authenticated?(Conn.t) :: boolean authenticated?(:cowboy_req.req) :: boolean","ref":"Wobserver.Security.html","title":"Wobserver.Security","type":"module"},{"doc":"Authenticates a given conn .","ref":"Wobserver.Security.html#authenticate/1","title":"Wobserver.Security.authenticate/1","type":"function"},{"doc":"Checks whether a given conn or req is authenticated.","ref":"Wobserver.Security.html#authenticated?/1","title":"Wobserver.Security.authenticated?/1","type":"function"},{"doc":"Provides System information.","ref":"Wobserver.System.html","title":"Wobserver.System","type":"module"},{"doc":"Provides a overview of all System information. Including: architecture , architecture information. cpu , cpu information. memory , memory usage. statistics , general System statistics. scheduler , scheduler utilization per scheduler.","ref":"Wobserver.System.html#overview/0","title":"Wobserver.System.overview/0","type":"function"},{"doc":"System overview information. Including: architecture , architecture information. cpu , cpu information. memory , memory usage. statistics , general System statistics. scheduler , scheduler utilization per scheduler.","ref":"Wobserver.System.html#t:t/0","title":"Wobserver.System.t/0","type":"type"},{"doc":"Handles general System info like architecture and cpu.","ref":"Wobserver.System.Info.html","title":"Wobserver.System.Info","type":"module"},{"doc":"Returns architecture information.","ref":"Wobserver.System.Info.html#architecture/0","title":"Wobserver.System.Info.architecture/0","type":"function"},{"doc":"Returns cpu information.","ref":"Wobserver.System.Info.html#cpu/0","title":"Wobserver.System.Info.cpu/0","type":"function"},{"doc":"Architecture information.","ref":"Wobserver.System.Info.html#t:t/0","title":"Wobserver.System.Info.t/0","type":"type"},{"doc":"Handles memory information.","ref":"Wobserver.System.Memory.html","title":"Wobserver.System.Memory","type":"module"},{"doc":"Returns memory usage.","ref":"Wobserver.System.Memory.html#usage/0","title":"Wobserver.System.Memory.usage/0","type":"function"},{"doc":"Memory information.","ref":"Wobserver.System.Memory.html#t:t/0","title":"Wobserver.System.Memory.t/0","type":"type"},{"doc":"Scheduler utilization per scheduler. Example: Wobserver.System.Scheduler.utilization [1.0, 0.0306945631032665, 0.03640598025269633, 0.05220935570330663, 0.04884165187164101, 0.08352432821297966, 0.11547042454628796, 0.2861211090456038]","ref":"Wobserver.System.Scheduler.html","title":"Wobserver.System.Scheduler","type":"module"},{"doc":"Calculates scheduler utilization per scheduler. Returns a list of floating point values range (0-1) indicating 0-100% utlization. Example: Wobserver.System.Scheduler.utilization [1.0, 0.0306945631032665, 0.03640598025269633, 0.05220935570330663, 0.04884165187164101, 0.08352432821297966, 0.11547042454628796, 0.2861211090456038]","ref":"Wobserver.System.Scheduler.html#utilization/0","title":"Wobserver.System.Scheduler.utilization/0","type":"function"},{"doc":"Handles system statistics.","ref":"Wobserver.System.Statistics.html","title":"Wobserver.System.Statistics","type":"module"},{"doc":"Returns system statistics.","ref":"Wobserver.System.Statistics.html#overview/0","title":"Wobserver.System.Statistics.overview/0","type":"function"},{"doc":"System statistics.","ref":"Wobserver.System.Statistics.html#t:t/0","title":"Wobserver.System.Statistics.t/0","type":"type"},{"doc":"Table (ets) information and listing.","ref":"Wobserver.Table.html","title":"Wobserver.Table","type":"module"},{"doc":"Creates an overview of table information based on the given table atom or number. If include_data is set to true , it will also contain the table data.","ref":"Wobserver.Table.html#info/2","title":"Wobserver.Table.info/2","type":"function"},{"doc":"Lists all tables with basic information. Note: data is not included.","ref":"Wobserver.Table.html#list/0","title":"Wobserver.Table.list/0","type":"function"},{"doc":"Sanitizes a table name and returns either the table id or name. Example: iex&gt; Wobserver.Table.sanitize :code :code iex&gt; Wobserver.Table.sanitize 1 1 iex&gt; Wobserver.Table.sanitize &quot;code&quot; :code iex&gt; Wobserver.Table.sanitize &quot;1&quot; 1","ref":"Wobserver.Table.html#sanitize/1","title":"Wobserver.Table.sanitize/1","type":"function"},{"doc":"Application listing and process hierachy.","ref":"Wobserver.Util.Application.html","title":"Wobserver.Util.Application","type":"module"},{"doc":"Retreives information about the application. The given app atom is used to find the started application. Containing: pid , the process id or port id. name , the registered name or pid/port. meta , the meta information of a process. (See: Wobserver.Util.Process.meta/1 .) children , the children of the process.","ref":"Wobserver.Util.Application.html#info/1","title":"Wobserver.Util.Application.info/1","type":"function"},{"doc":"Lists all running applications. The application information is given as a tuple containing: {name, description, version} . The name is an atom, while both the description and version are Strings.","ref":"Wobserver.Util.Application.html#list/0","title":"Wobserver.Util.Application.list/0","type":"function"},{"doc":"Helper functions and JSON encoders.","ref":"Wobserver.Util.Helper.html","title":"Wobserver.Util.Helper","type":"module"},{"doc":"Formats function information as readable string. Only name will be return if only name is given. Example: iex&gt; format_function {Logger, :log, 2} &quot;Logger.log/2&quot; iex&gt; format_function :format_function &quot;format_function&quot; iex&gt; format_function nil nil","ref":"Wobserver.Util.Helper.html#format_function/1","title":"Wobserver.Util.Helper.format_function/1","type":"function"},{"doc":"Parallel map implemented with Task . Maps the function over the enum using Task.async/1 and Task.await/1 .","ref":"Wobserver.Util.Helper.html#parallel_map/2","title":"Wobserver.Util.Helper.parallel_map/2","type":"function"},{"doc":"Converts Strings to module names or atoms. The given module string will be turned into atoms that get concatted.","ref":"Wobserver.Util.Helper.html#string_to_module/1","title":"Wobserver.Util.Helper.string_to_module/1","type":"function"},{"doc":"Metrics management for custom metrics and generators in wobserver.","ref":"Wobserver.Util.Metrics.html","title":"Wobserver.Util.Metrics","type":"module"},{"doc":"IO metrics.","ref":"Wobserver.Util.Metrics.html#io/0","title":"Wobserver.Util.Metrics.io/0","type":"function"},{"doc":"Loads custom metrics and metric generators from configuration and adds them to :wobserver . To add custom metrics set the :metrics option. The :metrics option must be a keyword list with the following keys: additional , for a keyword list with additional metrics. generators , for a list of metric generators. For more information and types see: Wobserver.Util.Metrics.register/1 . Example: config :wobserver , metrics : [ additional : [ example : { fn -&gt; [ red : 5 ] end , :gauge , &quot;Description&quot; } , ] , generators : [ &quot;&amp;MyApp.generator/0&quot; , fn -&gt; [ bottles : { fn -&gt; [ wall : 8 , floor : 10 ] end , :gauge , &quot;Description&quot; } ] end fn -&gt; [ server : { &quot;MyApp.Server.metrics/0&quot; , :gauge , &quot;Description&quot; } ] end ] ]","ref":"Wobserver.Util.Metrics.html#load_config/0","title":"Wobserver.Util.Metrics.load_config/0","type":"function"},{"doc":"Memory metrics. See: Wobserver.System.Memory.usage/0 .","ref":"Wobserver.Util.Metrics.html#memory/0","title":"Wobserver.Util.Metrics.memory/0","type":"function"},{"doc":"Lists all metrics. Every generator is called and the generated metrics are merged into the result.","ref":"Wobserver.Util.Metrics.html#overview/0","title":"Wobserver.Util.Metrics.overview/0","type":"function"},{"doc":"Registers a metrics or metric generators with :wobserver . The metrics parameter must always be a list of metrics or metric generators. Returns true if succesfully added. (otherwise false) The following inputs are accepted for metrics: keyword list, the key is the name of the metric and the value is the metric data. The following inputs are accepted for metric generators: list of callable functions. Every function should return a keyword list with as key the name of the metric and as value the metric data. For more information about how to format metric data see: Wobserver.Util.Metrics.Formatter.format_all/1 .","ref":"Wobserver.Util.Metrics.html#register/1","title":"Wobserver.Util.Metrics.register/1","type":"function"},{"doc":"Formatter.","ref":"Wobserver.Util.Metrics.Formatter.html","title":"Wobserver.Util.Metrics.Formatter","type":"behaviour"},{"doc":"Combines formatted metrics together. Arguments: metrics , a list of formatted metrics for one node.","ref":"Wobserver.Util.Metrics.Formatter.html#c:combine_metrics/1","title":"Wobserver.Util.Metrics.Formatter.combine_metrics/1","type":"callback"},{"doc":"Format a set of data with a label for a metric parser/aggregater. The following options can also be given: type , the type of the metric. The following values are currently supported: :gauge , :counter . help , a single line text description of the metric. formatter , a module implementing the Formatter behaviour to format metrics.","ref":"Wobserver.Util.Metrics.Formatter.html#format/5","title":"Wobserver.Util.Metrics.Formatter.format/5","type":"function"},{"doc":"Formats a keyword list of metrics using a given formatter . Metrics The key is the name of the metric and the value can be given in the following formats: data {data, type} {data, type, help} The different fields are: data , the actual metrics information. type , the type of the metric. Possible values : ` :gauge ` , ` :counter ` . help , a one line text description of the metric. The data can be given in the following formats: integer | float , just a single value. map , where every key will be turned into a type value. keyword list, where every key will be turned into a type value list of tuples with the following format: {value, labels} , where labels is a keyword list with labels and their values. function | string , a function or String that can be evaluated to a function, which, when called, returns one of the above data-types. Example: iex&gt; Wobserver.Util.Metrics.Formatter . format_all [ simple : 5 ] &quot;simple{node= \\&quot; 10.74.181.35 \\&quot; } 5 \\n &quot; iex&gt; Wobserver.Util.Metrics.Formatter . format_all [ simple : { 5 , :gauge } ] &quot;# TYPE simple gauge \\n simple{node= \\&quot; 10.74.181.35 \\&quot; } 5 \\n &quot; iex&gt; Wobserver.Util.Metrics.Formatter . format_all [ simple : { 5 , :gauge , &quot;Example desc.&quot; } ] &quot;# HELP simple Example desc. \\n # TYPE simple gauge \\n simple{node= \\&quot; 10.74.181.35 \\&quot; } 5 \\n &quot; iex&gt; Wobserver.Util.Metrics.Formatter . format_all [ simple : %{ floor : 5 , wall : 8 } ] &quot;simple{node= \\&quot; 10.74.181.35 \\&quot; ,type= \\&quot; floor \\&quot; } 5 \\n simple{node= \\&quot; 10.74.181.35 \\&quot; ,type= \\&quot; wall \\&quot; } 8 \\n &quot; iex&gt; Wobserver.Util.Metrics.Formatter . format_all [ simple : [ floor : 5 , wall : 8 ] ] &quot;simple{node= \\&quot; 10.74.181.35 \\&quot; ,type= \\&quot; floor \\&quot; } 5 \\n simple{node= \\&quot; 10.74.181.35 \\&quot; ,type= \\&quot; wall \\&quot; } 8 \\n &quot; iex&gt; Wobserver.Util.Metrics.Formatter . format_all [ simple : [ { 5 , [ location : :floor ] } , { 8 , [ location : :wall ] } ] ] &quot;simple{node= \\&quot; 10.74.181.35 \\&quot; ,location= \\&quot; floor \\&quot; } 5 \\n simple{node= \\&quot; 10.74.181.35 \\&quot; ,location= \\&quot; wall \\&quot; } 8 \\n &quot;","ref":"Wobserver.Util.Metrics.Formatter.html#format_all/2","title":"Wobserver.Util.Metrics.Formatter.format_all/2","type":"function"},{"doc":"Format a set of data with a label . The data must be given as a list of tuples with the following format: {value, labels} , where labels is a keyword list with labels and their values. The following options can also be given: type , the type of the metric. The following values are currently supported: :gauge , :counter . help , a single line text description of the metric.","ref":"Wobserver.Util.Metrics.Formatter.html#c:format_data/4","title":"Wobserver.Util.Metrics.Formatter.format_data/4","type":"callback"},{"doc":"Merges formatted sets of metrics from different nodes together. The merge should prevent double declarations of help and type. Arguments: metrics , a list of formatted sets metrics for multiple node.","ref":"Wobserver.Util.Metrics.Formatter.html#c:merge_metrics/1","title":"Wobserver.Util.Metrics.Formatter.merge_metrics/1","type":"callback"},{"doc":"Merges formatted sets of metrics from different nodes together using a given formatter . The merge should prevent double declarations of help and type. Arguments: metrics , a list of formatted sets metrics for multiple node.","ref":"Wobserver.Util.Metrics.Formatter.html#merge_metrics/2","title":"Wobserver.Util.Metrics.Formatter.merge_metrics/2","type":"function"},{"doc":"Prometheus formatter. Formats metrics in a for Prometheus readable way. See: https://prometheus.io/docs/instrumenting/writing_exporters/","ref":"Wobserver.Util.Metrics.Prometheus.html","title":"Wobserver.Util.Metrics.Prometheus","type":"module"},{"doc":"Combines formatted metrics together. Arguments: metrics , a list of formatted metrics for one node. Example: iex&gt; combine_metrics [ &quot;metric1{node=&quot; 127.0 . 0.1 &quot;} 5 \\n &quot; , &quot;metric2{node=&quot; 127.0 . 0.1 &quot;} 5 \\n &quot; ] &quot;metric1{node=&quot; 127.0 . 0.1 &quot;} 5 \\n &quot; , &quot;metric2{node=&quot; 127.0 . 0.1 &quot;} 5 \\n &quot;","ref":"Wobserver.Util.Metrics.Prometheus.html#combine_metrics/1","title":"Wobserver.Util.Metrics.Prometheus.combine_metrics/1","type":"function"},{"doc":"Format a set of data with a label for a Prometheus. The data must be given as a list of tuples with the following format: {value, labels} , where labels is a keyword list with labels and their values. The following options can also be given: type , the type of the metric. The following values are currently supported: :gauge , :counter . help , a single line text description of the metric.","ref":"Wobserver.Util.Metrics.Prometheus.html#format_data/4","title":"Wobserver.Util.Metrics.Prometheus.format_data/4","type":"function"},{"doc":"Merges formatted sets of metrics from different nodes together. The merge will filter out double declarations of help and type. Arguments: metrics , a list of formatted sets metrics for multiple node. Example: iex&gt; combine_metrics [ &quot;metric{node=&quot; 192.168 . 0.6 &quot;} 5 \\n &quot; , &quot;metric{node=&quot; 192.168 . 0.5 &quot;} 5 \\n &quot; ] &quot;metric{node=&quot; 192.168 . 0.6 &quot;} 5 \\n &quot; , &quot;metric{node=&quot; 192.168 . 0.7 &quot;} 5 \\n &quot;","ref":"Wobserver.Util.Metrics.Prometheus.html#merge_metrics/1","title":"Wobserver.Util.Metrics.Prometheus.merge_metrics/1","type":"function"},{"doc":"Helps discovering other nodes to connect to. The method used can be set in the config file by setting: config :wobserver , discovery : :dns , The following methods can be used: (default: :none ) :none , just returns the local node. :dns , use DNS to search for other nodes. The option discovery_search needs to be set to filter entries. :custom , a function as String. Example config No discovery: (is default) config :wobserver , port : 80 , discovery : :none Using dns as discovery service: config :wobserver , port : 80 , discovery : :dns , discovery_search : &quot;google.nl&quot; Using a custom function: config :wobserver , port : 80 , discovery : :custom , discovery_search : &amp; MyApp.CustomDiscovery . discover / 0 Using a anonymous function: config :wobserver , port : 80 , discovery : :custom , discovery_search : fn -&gt; [ ] end","ref":"Wobserver.Util.Node.Discovery.html","title":"Wobserver.Util.Node.Discovery","type":"module"},{"doc":"Discovers other nodes to connect to. The method used can be set in the config file by setting: config :wobserver , discovery : :dns , The following methods can be used: (default: :none ) :none , just returns the local node. :dns , use DNS to search for other nodes. The option discovery_search needs to be set to filter entries. :custom , a function as String. Example config No discovery: (is default) config :wobserver , discovery : :none Using dns: config :wobserver , discovery : :dns , discovery_search : &quot;google.nl&quot; Using a custom function: config :wobserver , discovery : :custom , discovery_search : &quot;&amp;MyApp.CustomDiscovery.discover/0&quot;","ref":"Wobserver.Util.Node.Discovery.html#discover/0","title":"Wobserver.Util.Node.Discovery.discover/0","type":"function"},{"doc":"Searches for a node in the discovered nodes. The search will be used to filter through names, hosts and host:port combinations. The special values for search are: local , will always return the local node.","ref":"Wobserver.Util.Node.Discovery.html#find/1","title":"Wobserver.Util.Node.Discovery.find/1","type":"function"},{"doc":"Retuns the local node.","ref":"Wobserver.Util.Node.Discovery.html#local/0","title":"Wobserver.Util.Node.Discovery.local/0","type":"function"},{"doc":"Remote node. TODO: Needs config.","ref":"Wobserver.Util.Node.Remote.html","title":"Wobserver.Util.Node.Remote","type":"module"},{"doc":"Performs an api call using the path on the remote_node and returns the result.","ref":"Wobserver.Util.Node.Remote.html#api/2","title":"Wobserver.Util.Node.Remote.api/2","type":"function"},{"doc":"Collects metrics from a given remote_node .","ref":"Wobserver.Util.Node.Remote.html#metrics/1","title":"Wobserver.Util.Node.Remote.metrics/1","type":"function"},{"doc":"Sets up a websocket connection to the given remote_node .","ref":"Wobserver.Util.Node.Remote.html#socket_proxy/1","title":"Wobserver.Util.Node.Remote.socket_proxy/1","type":"function"},{"doc":"Remote node information.","ref":"Wobserver.Util.Node.Remote.html#t:t/0","title":"Wobserver.Util.Node.Remote.t/0","type":"type"},{"doc":"Process and pid handling.","ref":"Wobserver.Util.Process.html","title":"Wobserver.Util.Process","type":"module"},{"doc":"Creates a complete overview of process stats based on the given pid . Including but not limited to: id , the process pid name , the registered name or nil . init , initial function or name. current , current function. memory , the total amount of memory used by the process. reductions , the amount of reductions. message_queue_length , the amount of unprocessed messages for the process.,","ref":"Wobserver.Util.Process.html#info/1","title":"Wobserver.Util.Process.info/1","type":"function"},{"doc":"Retreives a list of process summaries. Every summary contains: id , the process pid. name , the registered name or nil . init , initial function or name. current , current function. memory , the total amount of memory used by the process. reductions , the amount of reductions. message_queue_length , the amount of unprocessed messages for the process.","ref":"Wobserver.Util.Process.html#list/0","title":"Wobserver.Util.Process.list/0","type":"function"},{"doc":"Creates formatted meta information about the process based on the given pid . The information contains: init , initial function or name. current , current function. status , process status.","ref":"Wobserver.Util.Process.html#meta/1","title":"Wobserver.Util.Process.meta/1","type":"function"},{"doc":"Turns the argument pid into a pid or if not possible returns nil . It will accept: pids atoms / module names (registered processes) single integers a list of 3 integers a tuple of 3 integers a charlist in the format: '&lt;0.0.0&gt;' a String in the following formats: &quot;#PID&lt;0.0.0&gt;&quot; &quot;&lt;0.0.0&gt;&quot; atom / module name Example: iex&gt; Wobserver.Util.Process.pid pid(0, 33, 0) #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid :cowboy_sup #PID&lt;0.253.0&gt; iex&gt; Wobserver.Util.Process.pid Logger #PID&lt;0.213.0&gt; iex&gt; Wobserver.Util.Process.pid 33 #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid [0, 33, 0] #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid &#39;&lt;0.33.0&gt;&#39; #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid {0, 33, 0} #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid &quot;#PID&lt;0.33.0&gt;&quot; #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid &quot;&lt;0.33.0&gt;&quot; #PID&lt;0.33.0&gt; iex&gt; Wobserver.Util.Process.pid &quot;cowboy_sup&quot; #PID&lt;0.253.0&gt; iex&gt; Wobserver.Util.Process.pid &quot;Logger&quot; #PID&lt;0.213.0&gt; iex&gt; Wobserver.Util.Process.pid 4.5 nil","ref":"Wobserver.Util.Process.html#pid/1","title":"Wobserver.Util.Process.pid/1","type":"function"},{"doc":"Turns the argument pid into a pid or if not possible raises error. For example see: Wobserver.Util.Process.pid/1 .","ref":"Wobserver.Util.Process.html#pid!/1","title":"Wobserver.Util.Process.pid!/1","type":"function"},{"doc":"Creates formatted summary about the process based on the given pid . Every summary contains: id , the process pid. name , the registered name or nil . init , initial function or name. current , current function. memory , the total amount of memory used by the process. reductions , the amount of reductions. message_queue_length , the amount of unprocessed messages for the process.","ref":"Wobserver.Util.Process.html#summary/1","title":"Wobserver.Util.Process.summary/1","type":"function"},{"doc":"Modules handles WebSocket connects to the client.","ref":"Wobserver.Web.Client.html","title":"Wobserver.Web.Client","type":"module"},{"doc":"Handles the command given by the websocket interface. The current state is passed and can be modified. Returns a map as state.","ref":"Wobserver.Web.Client.html#client_handle/2","title":"Wobserver.Web.Client.client_handle/2","type":"function"},{"doc":"Handles process messages. Should not be used, the do is ignored and the state is returned unmodified.","ref":"Wobserver.Web.Client.html#client_info/2","title":"Wobserver.Web.Client.client_info/2","type":"function"},{"doc":"Starts the websocket client. Returns a map as state.","ref":"Wobserver.Web.Client.html#client_init/0","title":"Wobserver.Web.Client.client_init/0","type":"function"},{"doc":"","ref":"Wobserver.Web.Client.html#client_opts/0","title":"Wobserver.Web.Client.client_opts/0","type":"function"},{"doc":"Initialize the websocket connection.","ref":"Wobserver.Web.Client.html#init/2","title":"Wobserver.Web.Client.init/2","type":"function"},{"doc":"Gracefully handles websocked terminate. The reason , req and state are ignored.","ref":"Wobserver.Web.Client.html#terminate/3","title":"Wobserver.Web.Client.terminate/3","type":"function"},{"doc":"Handles incoming messages from the websocket client. The message is parsed and passed on to the client, which responds with an update state and possible reply.","ref":"Wobserver.Web.Client.html#websocket_handle/2","title":"Wobserver.Web.Client.websocket_handle/2","type":"function"},{"doc":"Handles incoming messages from processes. The message is passed on to the client, which responds with an update state and possible reply.","ref":"Wobserver.Web.Client.html#websocket_info/2","title":"Wobserver.Web.Client.websocket_info/2","type":"function"},{"doc":"Initialize the websocket connection by calling the implementing client. The req cowboy request is passed along to the client. The type and options are passed, but unused in the setup.","ref":"Wobserver.Web.Client.html#websocket_init/1","title":"Wobserver.Web.Client.websocket_init/1","type":"function"},{"doc":"ClientProxy will proxy websocket requests from Wobserver.Web.ClientSocket to a remote node. TODO: Needs config.","ref":"Wobserver.Web.ClientProxy.html","title":"Wobserver.Web.ClientProxy","type":"module"},{"doc":"Low level WebSocket handler Connects to the Javascript websocket and parses all requests. Example: defmodule Wobserver.Web.Client do use Wobserver.Web.ClientSocket alias Wobserver.System def client_init do { :ok , %{ } } end def client_handle ( :hello , state ) do { :reply , :ehlo , state } end def client_info ( :update , state ) do { :noreply , state } end end","ref":"Wobserver.Web.ClientSocket.html","title":"Wobserver.Web.ClientSocket","type":"behaviour"},{"doc":"Handles messages coming from the WS client. Return browser response.","ref":"Wobserver.Web.ClientSocket.html#c:client_handle/2","title":"Wobserver.Web.ClientSocket.client_handle/2","type":"callback"},{"doc":"Handles messages coming from other processes. Return browser response.","ref":"Wobserver.Web.ClientSocket.html#c:client_info/2","title":"Wobserver.Web.ClientSocket.client_info/2","type":"callback"},{"doc":"Initalizes the WebSocket. Return { :ok , initial state} or { :ok , initial state, socket timeout}.","ref":"Wobserver.Web.ClientSocket.html#c:client_init/0","title":"Wobserver.Web.ClientSocket.client_init/0","type":"callback"},{"doc":"Parses the JSON payload to an atom command and map data.","ref":"Wobserver.Web.ClientSocket.html#parse_command/1","title":"Wobserver.Web.ClientSocket.parse_command/1","type":"function"},{"doc":"Send a JSON encoded to the websocket client. The given message is JSON encoded (exception: :noreply ). The socket_state is used updated to reflect changes made by the client. The cowboy req is returned untouched.","ref":"Wobserver.Web.ClientSocket.html#send_response/2","title":"Wobserver.Web.ClientSocket.send_response/2","type":"function"},{"doc":"Sets up a websocket proxy to a given proxy . The state is modified to add in the new proxy.","ref":"Wobserver.Web.ClientSocket.html#setup_proxy/2","title":"Wobserver.Web.ClientSocket.setup_proxy/2","type":"function"},{"doc":"Response to browser.","ref":"Wobserver.Web.ClientSocket.html#t:response/0","title":"Wobserver.Web.ClientSocket.response/0","type":"type"},{"doc":"Drop-in Phoenix Socket for easier integration in to Phoenix endpoints Example: defmodule MyPhoenixServer.Endpoint do socket &quot;/wobserver&quot; , Wobserver.Web.PhoenixSocket # The path should be the same as the router path ... end","ref":"Wobserver.Web.PhoenixSocket.html","title":"Wobserver.Web.PhoenixSocket","type":"module"},{"doc":"Main router. Splits into two paths: /api , for all json api calls, handled by Wobserver.Web.Router.Api . / , for all static assets, handled by Wobserver.Web.Router.Static .","ref":"Wobserver.Web.Router.html","title":"Wobserver.Web.Router","type":"module"},{"doc":"Main api router. Returns the following resources: /about =&gt; Wobserver.about/0 . /nodes =&gt; Wobserver.NodeDiscovery.discover/0 . Splits into the following paths: /system , for all system information, handled by Wobserver.Web.Router.System . All paths also include the option of entering a node name before the path.","ref":"Wobserver.Web.Router.Api.html","title":"Wobserver.Web.Router.Api","type":"module"},{"doc":"Base Router module, includes standard helpers and plugs.","ref":"Wobserver.Web.Router.Base.html","title":"Wobserver.Web.Router.Base","type":"module"},{"doc":"Helper methods for routers.","ref":"Wobserver.Web.Router.Helper.html","title":"Wobserver.Web.Router.Helper","type":"module"},{"doc":"Sends a JSON encoded response back to the client. The https status will be 200 or 500 if the given data can not be JSON encoded. The conn content type is set to application/json , only if the data could be encoded.","ref":"Wobserver.Web.Router.Helper.html#send_json_resp/2","title":"Wobserver.Web.Router.Helper.send_json_resp/2","type":"function"},{"doc":"Metrics router. Returns the following resources: / =&gt; All metrics for the local node. /memory =&gt; Memory metrics for the local node. /io =&gt; IO metrics for the local node.","ref":"Wobserver.Web.Router.Metrics.html","title":"Wobserver.Web.Router.Metrics","type":"module"},{"doc":"Static router mostly for the browsers interface. Returns the following resources: / , for the main html page. /main.css , for main css stylesheet. /app.js , for the Javascript code. /license , for the MIT license information.","ref":"Wobserver.Web.Router.Static.html","title":"Wobserver.Web.Router.Static","type":"module"},{"doc":"System router. Returns the following resources: / =&gt; Wobserver.System.overview/0 . /architecture =&gt; Wobserver.System.Info.architecture/0 . /cpu =&gt; Wobserver.System.Info.cpu/0 . /memory =&gt; Wobserver.System.Memory.usage/0 . /statistics =&gt; Wobserver.System.Statistics.overview/0 .","ref":"Wobserver.Web.Router.System.html","title":"Wobserver.Web.Router.System","type":"module"},{"doc":"Sets up the main routers with Cowboy.","ref":"WobserverNG.Application.html","title":"WobserverNG.Application","type":"module"},{"doc":"The port the application uses.","ref":"WobserverNG.Application.html#port/0","title":"WobserverNG.Application.port/0","type":"function"},{"doc":"Starts wobserver . The option :mode is used to determine how to start wobserver . The following values are possible: :standalone , starts a supervisor that supervises cowboy. :plug , passes the Agent storage of the metrics back as pid, without starting any extra processes. In :plug mode no cowboy/ranch server is started, so the wobserver router will need to be called from somewhere else. Note: both type and args are unused.","ref":"WobserverNG.Application.html#start/2","title":"WobserverNG.Application.start/2","type":"function"},{"doc":"This repo is an effort of keeping the original wobserver updated with latest version of Elixir. Original wobserver is a wonderful project making remotely inspecting Elixir developing easy, but it has stopped updating itself after 2017. Both Elixir the language and Erlang OTP platform have changed a lot, so need some effort to change it and make it work again. This repo is targeting of doing that. The current effort is focusing on making it work with Elixir ~ v1.14.x Erlang/OTP 25 All functions are kept the same as origianl project, thus for knowing what it is, how to use it, and browse all functionalities, please refer to origianl README or simply original wobserver repo . This project is licensed with same MIT license as in original wobserver project.","ref":"readme.html","title":"Wobserver NG","type":"extras"},{"doc":"I have published this repo with name &quot;wobserver_ng&quot; to Hex.pm . So if want to use it in your project, simply add {:wobserver_ng, &quot;~&gt; 1.14&quot;} to your deps function in mix.exs , like below defp deps do [ ..., {:wobserver_ng, &quot;~&gt; 1.14&quot;}, ... ] end","ref":"readme.html#how-to-use-it","title":"Wobserver NG - How to use it","type":"extras"}]